"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _Observable = _interopRequireDefault(require("./Observable"));

var _Watch = _interopRequireDefault(require("./Watch"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var Vue = /*#__PURE__*/function () {
  function Vue(options) {
    var _this = this;

    (0, _defineProperty2.default)(this, "$options", void 0);
    (0, _defineProperty2.default)(this, "$children", void 0);
    (0, _defineProperty2.default)(this, "$data", void 0);
    this.$options = options;
    this.$data = (0, _Observable.default)(Object.assign({}, options.methods, options.data), options.computed || null);

    if (options.data) {
      Object.keys(Object.assign({}, options.methods, options.computed, options.data)).forEach(function (key) {
        Object.defineProperty(_this, key, {
          get: function get() {
            return this.$data[key];
          },
          set: function set(v) {
            this.$data[key] = v;
          }
        });
      });
    }

    new _Watch.default(this.$data, function () {
      // strict mode
      // with (this.$data) {
      return options.render.call(_this); // }
    }, (0, _debounce.default)(function (children) {
      _this.$children = children;

      _this.render();
    })); // Init

    this.$children = options.render.call(this.$data);
    this.render();
  }

  var _proto = Vue.prototype;

  _proto.render = function render() {
    console.log(this.$children);
  };

  return Vue;
}();

exports.default = Vue;