"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.CurrentWatchDep = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get = _interopRequireDefault(require("lodash/get"));

var _shallowequal = _interopRequireDefault(require("shallowequal"));

var CurrentWatchDep = {
  current: null
};
exports.CurrentWatchDep = CurrentWatchDep;

var Watch = /*#__PURE__*/function () {
  function Watch(data, path, fn) {
    (0, _defineProperty2.default)(this, "last", void 0);
    (0, _defineProperty2.default)(this, "exp", void 0);
    (0, _defineProperty2.default)(this, "watchFn", void 0);
    (0, _defineProperty2.default)(this, "deps", []);
    this.watchFn = fn;
    this.exp = typeof path === "string" ? function () {
      return (0, _get.default)(data, path);
    } : function () {
      return path.call(data);
    };
    var lastWatchDep = CurrentWatchDep.current;
    CurrentWatchDep.current = this;
    this.last = this.exp();
    CurrentWatchDep.current = lastWatchDep;
  }

  var _proto = Watch.prototype;

  _proto.clearDeps = function clearDeps() {
    this.deps.forEach(function (cb) {
      return cb();
    });
    this.deps = [];
  };

  _proto.addDep = function addDep(notify) {
    var _this = this;

    this.deps.push(notify.sub(function () {
      _this.check();
    }));
  };

  _proto.check = function check() {
    this.clearDeps();
    var lastWatchDep = CurrentWatchDep.current;
    CurrentWatchDep.current = this;
    var newValue = this.exp();
    CurrentWatchDep.current = lastWatchDep;
    var oldValue = this.last;

    if (!(0, _shallowequal.default)(oldValue, newValue)) {
      this.last = newValue;
      this.watchFn(newValue, oldValue);
    }
  };

  return Watch;
}();

exports.default = Watch;