"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _Observable = _interopRequireDefault(require("./Observable"));

var _Vue = _interopRequireDefault(require("./Vue"));

var data = (0, _Observable.default)({
  idx: 1,
  name: "test",
  info: {
    age: 18
  }
}, {
  fullName: function fullName() {
    return this.name + this.info.age;
  }
}); // data.$watch("info.age", (a, b) => console.log("age changed:", a));
// data.$watch("name", (a, b) => console.log("name changed:", a));

data.$watch(function () {
  console.log("trigger c");

  if (this.idx % 3) {
    return this.name;
  } else {
    return this.info.age;
  }
}, function (a, b) {
  return console.log("trigger changed:", a);
});
data.$watch("fullName", function (a, b) {
  return console.log("fullName changed:", a);
}); // console.log(data.fullName, "fullName");
// data.name = "hello";
// data.info.age = 20;
// data.info.age = 21;
// data.info.age = 22;
// data.idx = 3;
// data.name = "hello2";
// data.idx = 6;
// data.name = "vvvs";

var vue = new _Vue.default({
  data: {
    counter: 1,
    age: 10,
    name: "vue",
    desc: "test"
  },
  computed: {
    fullName: function fullName() {
      return this.name + "(" + this.desc + ":" + this.counter % 10 + ")";
    }
  },
  methods: {
    count: function count() {
      this.counter++;

      if (this.counter % 12 === 0) {
        this.age++;
      }
    }
  },
  render: function render() {
    return "render: " + this.counter + "|" + this.fullName + "|" + this.age;
  }
});
setInterval(function () {
  vue.count();
}, 1000);