"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var get_1 = require("lodash/get");
var shallowequal_1 = require("shallowequal");
var Watch = /** @class */ (function () {
    function Watch(data, path, fn) {
        this.watchFn = fn;
        var exp = typeof path === "string"
            ? function () {
                return get_1.default(data, path);
            }
            : function () { return path.call(data); };
        this.last = exp();
    }
    Watch.prototype.check = function () {
        var newValue = this.exp();
        var oldValue = this.last;
        if (!shallowequal_1.default(oldValue, newValue)) {
            this.last = newValue;
            this.watchFn(newValue, oldValue);
        }
    };
    return Watch;
}());
exports.default = Watch;
